const ErrorLVL = {
    Warn: 'Warn',
    Crit: 'Crit'
};

const FSError = {
    name: 'FSError',
    message: 'Failed to read local filesystem',
    lvl: ErrorLVL.Crit,
};

const ContextRequestTimeoutError = {
    name: 'ContextRequestTimeoutError',
    message: 'Context request timeout',
    lvl: ErrorLVL.Crit,
};

const RequestTimeoutError = {
    name: 'RequestTimeoutError',
    message: 'Request timeout',
    lvl: ErrorLVL.Warn,
};

const ContextRequestError = {
    name: 'ContextRequestError',
    message: 'Failed to get context',
    lvl: ErrorLVL.Crit,
};

const APIRequestError = {
    name: 'APIRequestError',
    message: 'Failed to request API server',
    lvl: ErrorLVL.Warn,
};

const IntegrationKeyNotFoundError = {
    name: 'IntegrationKeyNotFoundError',
    message: 'Key not found',
    lvl: ErrorLVL.Warn,
    default: '',
};

const IntegrationNotFoundError = {
    name: 'IntegrationNotFoundError',
    message: 'Integration not found',
    lvl: ErrorLVL.Crit,
};

const MissingReferenceError = {
    name: 'MissingReferenceError',
    message: 'Failed to resolve the required reference',
    lvl: ErrorLVL.Crit,
};

const AuthenticationError = {
    name: 'AuthenticationError',
    message: 'Failed to authenticate to the specified secret-store',
    lvl: ErrorLVL.Crit,
};

const InitError = {
    name: 'InitializationError',
    message: 'Failed to build client',
    lvl: ErrorLVL.Crit,
};

module.exports = {
    ErrorLVL,
    Type: {
        ContextRequestTimeoutError,
        ContextRequestError,
        IntegrationKeyNotFoundError,
        IntegrationNotFoundError,
        RequestTimeoutError,
        APIRequestError,
        FSError,
        MissingReferenceError,
        AuthenticationError,
        InitError,
    }
};
