export = Vault;
declare class Vault {
    /**
     * secret reference
     * @typedef {Object} SecretReference
     * @property {string} path
     * @property {string} key
     */
    /**
     * finds the path and key from a context and a variable string
     * @param {any} ctx vault secret-store context
     * @param {string | undefined} variable variable string
     * @returns {SecretReference} secret reference
     */
    static getReferences(ctx: any, variable?: string | undefined): {
        path: string;
        key: string;
    };
    constructor(apiUrl: any, auth: any);
    _apiUrl: any;
    _auth: any;
    /**
     * Initializes the vault client
     */
    init(): Promise<void>;
    _client: NodeVault.client;
    read(path: any): Promise<any>;
    _gcpLogin(auth: any): Promise<void>;
    _request(url: any, { headers, params }: {
        headers: any;
        params: any;
    }): Promise<any>;
    _kubernetesLogin(auth: any): Promise<void>;
}
import NodeVault = require("node-vault");
